---------------------------------------------------------------------
-- SOAP over HTTP.
-- See Copyright notice in license.html
-- $Id: http.lua,v 1.1 2004/03/24 19:27:37 tomas Exp $
---------------------------------------------------------------------

require"socket.http"
require"ltn12"
require"soap"

local post = socket.http.post

soap.http = {}

---------------------------------------------------------------------
-- Call a remote method.
-- @param url String with the location of the server.
-- @param namespace
---------------------------------------------------------------------
function soap.http.call (url, namespace, method, entries, headers)
	local body = {}
	local data = soap.encode (namespace, method, entries, headers)
	local rc, code, headers = socket.http.request {
		url = url,
		method = "POST",
		source = ltn12.source.string(data),
		headers = {
			["Content-type"] = "text/xml",
			["SOAPAction"] = '"'..method..'"',
			["Content-length"] = tostring(string.len(data)),
		},
		sink = ltn12.sink.table(body)
	}
	body = table.concat(body)
	if rc == 1 and tonumber (code) == 200 then
		return soap.decode (body)
	else
		error (code.."\n\n"..body)
	end
end
